#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
# generated by wxGlade 0.6.3 on Thu Aug 27 13:30:40 2009

#  Copyright 2009, Erik Hahn

#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import wx
from path import path
from tag_wrapper import TagException

from lib import *

_ = gettext("cli")

# begin wxGlade: extracode
# end wxGlade



class RootFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: RootFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.panel_input = wx.Panel(self, -1)
        self.panel_buttons = wx.Panel(self, -1)
        self.list_ctrl_preview = wx.ListCtrl(self, -1, style=wx.LC_REPORT|wx.SUNKEN_BORDER)
        self.button_refresh = wx.Button(self.panel_buttons, -1, _("Refresh"))
        self.button_copy = wx.Button(self.panel_buttons, -1, _("Copy"))
        self.button_move = wx.Button(self.panel_buttons, -1, _("Move"))
        self.button_exit = wx.Button(self.panel_buttons, -1, _("Exit"))
        self.label_dir = wx.StaticText(self.panel_input, -1, _("Directory: "))
        self.text_ctrl_dir = wx.TextCtrl(self.panel_input, -1, "")
        self.label_pattern = wx.StaticText(self.panel_input, -1, _("Pattern: "))
        self.text_ctrl_pattern = wx.TextCtrl(self.panel_input, -1, "")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.refresh, self.button_refresh)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_exit)
        # end wxGlade

        # Add columns to list
        self.list_ctrl_preview.InsertColumn(0, _("File"))
        self.list_ctrl_preview.InsertColumn(1, _("Target"))

        # Init some vars
        self.current_dir = None # TODO: maybe ask at startup
        self.pairs = {}

    def __set_properties(self):
        # begin wxGlade: RootFrame.__set_properties
        self.SetTitle(_("Ordnung"))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: RootFrame.__do_layout
        sizer_root = wx.BoxSizer(wx.VERTICAL)
        sizer_input = wx.BoxSizer(wx.VERTICAL)
        sizer_pattern = wx.BoxSizer(wx.HORIZONTAL)
        sizer_dir = wx.BoxSizer(wx.HORIZONTAL)
        sizer_top = wx.BoxSizer(wx.HORIZONTAL)
        sizer_buttons = wx.BoxSizer(wx.VERTICAL)
        sizer_top.Add(self.list_ctrl_preview, 1, wx.EXPAND, 0)
        sizer_buttons.Add(self.button_refresh, 0, wx.ALL, 4)
        sizer_buttons.Add(self.button_copy, 0, wx.ALL, 4)
        sizer_buttons.Add(self.button_move, 0, wx.ALL, 4)
        sizer_buttons.Add(self.button_exit, 0, wx.ALL, 4)
        self.panel_buttons.SetSizer(sizer_buttons)
        sizer_top.Add(self.panel_buttons, 0, wx.EXPAND, 0)
        sizer_root.Add(sizer_top, 1, wx.EXPAND, 0)
        sizer_dir.Add(self.label_dir, 0, 0, 0)
        sizer_dir.Add(self.text_ctrl_dir, 1, wx.EXPAND, 0)
        sizer_input.Add(sizer_dir, 1, wx.EXPAND, 0)
        sizer_pattern.Add(self.label_pattern, 0, 0, 0)
        sizer_pattern.Add(self.text_ctrl_pattern, 1, wx.EXPAND, 0)
        sizer_input.Add(sizer_pattern, 1, wx.EXPAND, 0)
        self.panel_input.SetSizer(sizer_input)
        sizer_root.Add(self.panel_input, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_root)
        sizer_root.Fit(self)
        self.Layout()
        # end wxGlade


    def onClose(self, event): # wxGlade: RootFrame.<event_handler>
        sys.exit(0)


    def _updateListCtrl(self):
        list = self.list_ctrl_preview
        list.DeleteAllItems()
        for i in self.pairs:
            if self.pairs[i] is not None:
                list.InsertStringItem(0, i)
                list.SetStringItem(0, 1, self.pairs[i])


    def _updateFileList(self):
        dirfield = self.text_ctrl_dir.GetValue()
        if dirfield != self.current_dir:
            self.current_dir = dirfield
            files = path(dirfield).walkfiles() # TODO: non-recursive as option
            for file in files:
                if issupportedfile(file):
                    try:
                        target = newpath(file,
                                self.text_ctrl_pattern.GetValue())
                    except: pass
                    else:
                        self.pairs[file] = target


    def refresh(self, event): # wxGlade: RootFrame.<event_handler>
        self._updateFileList()
        self._updateListCtrl()

# end of class RootFrame

def main():
    ordnung = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_root = RootFrame(None, -1, "")
    ordnung.SetTopWindow(frame_root)
    frame_root.Show()
    ordnung.MainLoop()

if __name__ == "__main__":
    main()
