#! /usr/bin/env python

from distutils.core import setup, Command

from path import path

import sys, os, errno
from glob import glob
from subprocess import call

class BuildMo(Command):
    user_options = []

    def initialize_options(self):
        self._dir = os.getcwd()

    def finalize_options(self):
        pass

    def run(self):
        """
        Rebuild all .mo files
        """
        for i in glob("po/**/*.po"):
            locale = os.path.split(os.path.splitext(i)[0])[1]
            domain = i.split(os.sep)[1]
            modir = os.path.join("locale", locale, "LC_MESSAGES")
            mofile = os.path.join(modir, domain + ".mo")
            pofile = os.path.join("po", domain, locale + ".po")
            try:
                os.makedirs(modir)
            except OSError, exc:
                if exc.errno == errno.EEXIST:
                    pass
                else: raise
            call(["msgfmt", "-o" + mofile , pofile])


def data_files():
    if not os.path.exists("locale"): return
    data_files = []
    for i in path("locale").walkdirs():
        p = path(i)
        if p.files() != []:
            data_files.append((p, p.files()))
    return data_files

setup(name="Ordnung",
        version="0.1.1",
        description="Music file sorter and renamer",
        author="Erik Hahn",
        author_email="erik_hahn@gmx.de",
        url="https://launchpad.net/ordnung",
        packages=["ordnung"],
        scripts=["scripts/ordnung"],
        data_files=data_files(),
        cmdclass={"build_mo": BuildMo}
        )
